package md

type WalletFlowNode struct {
	Id           int64  `json:"id"`
	Uid          int64  `json:"uid"`           // 用户 ID
	Direction    int    `json:"direction"`     // 方向:1.收入 2.支出
	Amount       string `json:"amount"`        // 变动金额
	BeforeAmount string `json:"before_amount"` // 变动前金额
	AfterAmount  string `json:"after_amount"`  // 变动后金额
	SysFee       string `json:"sys_fee"`       // 手续费
	OrdId        string `json:"ord_id"`        // 对应订单编号
	Title        string `json:"title"`         // 标题
	Kind         int    `json:"kind"`          // 1:管理员操作增加余额 2:管理员操作扣除余额 3:蛋蛋能量兑换余额 4:余额兑换蛋蛋能量
	State        int    `json:"state"`         // 1未到账,2已到账
	Memo         string `json:"memo"`          // 备注
	CreateTime   string `json:"create_time"`   // 创建时间
	UpdateTime   string `json:"update_time"`   // 更新时间
}

type GetAmountFlowResp struct {
	List     []WalletFlowNode `json:"list"`
	Paginate Paginate         `json:"paginate"`
}

type WithdrawGetAmountResp struct {
	Amount string `json:"amount"` // 余额
}

type WithdrawApplyReq struct {
	Amount string `json:"amount"` // 金额
	Kind   int    `json:"kind"`   // 提现方式(1:支付宝 2:微信)
}

type GetWithdrawConditionResp struct {
	IsRealName   bool `json:"is_real_name"`   // 是否实名
	IsBindAlipay bool `json:"is_bind_alipay"` // 是否绑定阿里账户
	IsBindWx     bool `json:"is_bind_wx"`     // 是否绑定微信账户
}

type BindAlipayAccountReq struct {
	UserId string `json:"user_id"` // 支付宝用户id
	OpenId string `json:"open_id"` // 支付宝用户open_id
	AppId  string `json:"app_id"`  // 支付宝商户应用appid
	Ext    string `json:"ext"`     // 拓展字段
}

type BindWxPayAccountReq struct {
	UserId string `json:"user_id"` // 微信用户 id
	OpenId string `json:"open_id"` // 微信用户 open_id
	AppId  string `json:"app_id"`  // 微信应用 appid
	Ext    string `json:"ext" `    // 拓展字段
}
